#include "Optimizer.h"
#include "Parser.h"
#include <iostream>

using namespace zp;

std::unique_ptr<BlockInstruction> AstVisitor::visit(Block& block)
{
    return block.accept(*this);
}


std::unique_ptr<BlockInstruction> Optimizer::visitInstructionBlock(InstructionBlock& ib)
{
    std::cout << "InstructionBlock" << std::endl;
    bool isSimple = true;
    for (auto instr : ib.instructions) {
        switch(instr) {
            case Instruction::COMMA:
            case Instruction::DOT:
            
        }
    }
    return std::make_unique<SimpleBlockInstruction>();
}


std::unique_ptr<BlockInstruction> Optimizer::visitUnionBlock(UnionBlock& ub)
{
    std::cout << "UnionBlock" << std::endl;
    for (auto& block : ub.instructions) {
        visit(*block.get());
    }
    return std::make_unique<SimpleBlockInstruction>();
}


std::unique_ptr<BlockInstruction> Optimizer::visitLoop(Loop& loop)
{
    std::cout << "Loop" << std::endl;
    for (auto& block : loop.instructions) {
        visit(*block.get());
    }
    return std::make_unique<SimpleBlockInstruction>();
}


